-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function CampaignFramework:StartActivity()
	-- Campaign definition part. Here you define missions for your campaign.
	-- Description - Mission description that is showed on top of the screen when mission selected
	-- PlatePresset - AEmitter with coloured mission thumbnail which is showed when mission is available
	-- PlateMonoPresset - AEmitter with monochrome mission thumbnail which is showed when mission is not available
	-- Activity - Activity name (specified in Activities.ini) that starts selected mission
	self.Missions = {};
	self.Missions[1] = {};
	self.Missions[1]["Description"] = "Mission 01\nMission 01 Description";
	self.Missions[1]["PlatePreset"] = "PlateMission01";
	self.Missions[1]["PlateMonoPreset"] = "PlateMonoMission01";
	self.Missions[1]["Activity"] = "CampaignMission01";
	
	self.Missions[2] = {};
	self.Missions[2]["Description"] = "Mission 02\nMission 02 Description";
	self.Missions[2]["PlatePreset"] = "PlateMission02";
	self.Missions[2]["PlateMonoPreset"] = "PlateMonoMission02";
	self.Missions[2]["Activity"] = "CampaignMission02";

	self.Missions[3] = {};
	self.Missions[3]["Description"] = "Mission 03\nMission 03 Description";
	self.Missions[3]["PlatePreset"] = "PlateMission03";
	self.Missions[3]["PlateMonoPreset"] = "PlateMonoMission03";
	self.Missions[3]["Activity"] = "CampaignMission01";

	self.Missions[4] = {};
	self.Missions[4]["Description"] = "Mission 04\nMission 04 Description";
	self.Missions[4]["PlatePreset"] = "PlateMission04";
	self.Missions[4]["PlateMonoPreset"] = "PlateMonoMission04";
	self.Missions[4]["Activity"] = "CampaignMission02";

	self.Missions[5] = {};
	self.Missions[5]["Description"] = "Mission 05\nMission 05 Description";
	self.Missions[5]["PlatePreset"] = "PlateMission05";
	self.Missions[5]["PlateMonoPreset"] = "PlateMonoMission05";
	self.Missions[5]["Activity"] = "CampaignMission01";

	self.Missions[6] = {};
	self.Missions[6]["Description"] = "Mission 06\nMission 06 Description";
	self.Missions[6]["PlatePreset"] = "PlateMission06";
	self.Missions[6]["PlateMonoPreset"] = "PlateMonoMission06";
	self.Missions[6]["Activity"] = "CampaignMission02";
	
	self.Selection = 1;
	self.XTiles = 3; -- Plates per row
	self.YTiles = 3;

	self.Factions = {CLONE = 1, DUMMY = 2 , RONIN = 3};
	self.Modules = {};
	self.LightWeaponSets = {};
	self.HeavyWeaponSets = {};
	self.ExplosiveSets = {};
	self.ActorSets = {};
	
	-- Different probabilities.
	-- 1 - Probability to get a heavy weapon
	-- 2 - Probability to get a secondary weapon
	-- 3 - Probability to get an explosive
	-- 4 - Probability to a second explosive
	-- Example:
	-- self.Probabilities[self.Factions.CLONE] = {0.35 , 0.30 , 0.60 , 0.30};
	self.Probabilities = {}; 
	
	self.Modules[self.Factions.CLONE] = "Coalition.rte";
	self.Modules[self.Factions.DUMMY] = "Dummy.rte";
	self.Modules[self.Factions.RONIN] = "Ronin.rte";
	
	self.LightWeaponSets[self.Factions.CLONE] = {"Shotgun", "Compact Assault Rifle" , "Sniper Rifle" , "Grenade Launcher" }
	self.HeavyWeaponSets[self.Factions.CLONE] = {"Auto Shotgun", "Assault Rifle" , "Heavy Sniper Rifle" , "Grenade Launcher" , "Uber Cannon" , "Revolver Cannnon"}
	self.ExplosiveSets[self.Factions.CLONE] = {"Grenade"};
	self.ActorSets[self.Factions.CLONE] = {"Soldier Light" , "Soldier Heavy"};
	self.Probabilities[self.Factions.CLONE] = {0.65 , 0.30 , 0.25 , 0.15};
	
	self.LightWeaponSets[self.Factions.DUMMY] = {"Rail Pistol", "Nailgun" , "Blaster" , "Sniper Rifle" , "Nailer Cannon" }
	self.HeavyWeaponSets[self.Factions.DUMMY] = {"Blaster" , "Sniper Rifle" , "Nailer Cannon" , "Repeater" , "Grenade Launcher" , "Destroyer Cannon" , "Annihiliator"}
	self.ExplosiveSets[self.Factions.DUMMY] = {"Impulse Grenade"};
	self.ActorSets[self.Factions.DUMMY] = {"Dummy"};
	self.Probabilities[self.Factions.DUMMY] = {0.65 , 0.35 , 0.25 , 0.15};

	self.LightWeaponSets[self.Factions.RONIN] = {"Peacemaker", "TommyGun" , "Uzi" , "Shortgun" , "Rifle Long" , "Pumpgun" }
	self.HeavyWeaponSets[self.Factions.RONIN] = {"M16", "YAK47" , "M1600" , "Sniper Rifle" , "Spaz12" , "Bazooka" , "Spaz1200"}
	self.ExplosiveSets[self.Factions.RONIN] = {"Pineapple Grenade" , "Stick Grenade"};
	self.ActorSets[self.Factions.RONIN] = {"Dafred" , "Mia" , "Dimitri" , "Sandra" , "Brutus" , "Gordon"};
	self.Probabilities[self.Factions.RONIN] = {0.65 , 0.30 , 0.25 , 0.15};

	self.AttackFaction = self.Factions.CLONE;
	self.DefendFaction = self.Factions.DUMMY;
	
	self.AttackSpawnTimer = Timer();
	self.AttackSpawnTimer:Reset();
	self.AttackSpawnInterval = 3500;

	self.DefendSpawnTimer = Timer();
	self.DefendSpawnTimer:Reset();
	self.DefendSpawnInterval = 3500;
	
   	-- Team 2 is always CPU
   	self.CPUTeam = Activity.TEAM_2;
	self.PlayerTeam = Activity.TEAM_1;
	self.RogueTeam = -1;

	self.AttackTeam = self.RogueTeam;
	self.DefendTeam = self.CPUTeam;
	
	self.MOIDLimit = 200;
	
	-- All the things below are not intended to be eduted by user!
	self.HelpText = "Use MOVE LEFT and MOVE RIGHT to chose mission, press FIRE to start mission\n";

	self.AvailableMissions = {};
	
	for i = 1 , #self.Missions do
		self.AvailableMissions[i] = CF_IsMissionAvailable("CampaignFramework.rte" , i)
	end
	
	self.PlatesPos = {};
	
	for i = 1 , #self.Missions do
		self.PlatesPos[i] = Vector(72 + (SceneMan.Scene.Width / 2) - (self.XTiles * 160 / 2) + ((i - 1) % self.XTiles) * 160  , 
									    (SceneMan.Scene.Height / 2) - (self.YTiles * 160 / 2) + (math.ceil(i / self.XTiles)) * 160);
	end
	
	self.Plates = {};
	for i = 1, #self.Missions do
		if self.AvailableMissions[i] then
			self.Plates[i] = CreateAEmitter(self.Missions[i]["PlatePreset"] , "CampaignFramework.rte");
		else
			self.Plates[i] = CreateAEmitter(self.Missions[i]["PlateMonoPreset"] , "CampaignFramework.rte");
		end
		self.Plates[i].Pos = self.PlatesPos[i]
		MovableMan:AddParticle(self.Plates[i]);
	end
	
	self:RedrawPlate(self.Selection , true);
	
	--Give the player no money.
	self:SetTeamFunds(Activity.TEAM_1,0);
	--Make an invisible brain.
	self.brain = CreateActor("Brain Case");
	self.brain.Scale = 0;
	self.brain.Team = Activity.TEAM_1;
	self.brain.Pos = Vector(SceneMan.Scene.Width / 2,SceneMan.Scene.Height / 2);
	MovableMan:AddActor(self.brain);
	self:SetPlayerBrain(self.brain,Activity.TEAM_1);
	self:SwitchToActor(self.brain,Activity.PLAYER_1,-1);
	
	for i = 1 , 5 do
		self:SpawnDefend(Vector(math.random(SceneMan.Scene.Width) , 420));
		self:SpawnAttack(Vector(math.random(SceneMan.Scene.Width) , 420));
	end
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
-- This function is called when mission is paused
function CampaignFramework:PauseActivity(pause)
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
-- This function is called after mission has ended
function CampaignFramework:EndActivity()
end
-----------------------------------------------------------------------------------------
-- Redraw mission plate
-----------------------------------------------------------------------------------------
function CampaignFramework:RedrawPlate(platenum , isselected)
	MovableMan:RemoveParticle(self.Plates[platenum]);
	self.Plates[platenum] = nil;

	if isselected then
		self.Plates[platenum] = CreateAEmitter(self.Missions[platenum]["PlatePreset"] , "CampaignFramework.rte");
		self.Plates[platenum].Scale = 1.22;
	else
		if self.AvailableMissions[platenum] then
			self.Plates[platenum] = CreateAEmitter(self.Missions[platenum]["PlatePreset"] , "CampaignFramework.rte");
		else
			self.Plates[platenum] = CreateAEmitter(self.Missions[platenum]["PlateMonoPreset"] , "CampaignFramework.rte");
		end
	end
	self.Plates[platenum].Pos = self.PlatesPos[platenum]
	MovableMan:AddParticle(self.Plates[platenum]);	
end
-----------------------------------------------------------------------------------------
-- Make weapon. actorside - actor faction number , is light - weapon list flag to select weapon from
-----------------------------------------------------------------------------------------
function CampaignFramework:MakeWeapon(actorside , islight)
	local weapon;
	local r1 , r2;
	
	weapon = nil;
	r1 = math.random(#self.LightWeaponSets[actorside]);
	r2 = math.random(#self.HeavyWeaponSets[actorside]);
	
	if islight then
		weapon = CreateHDFirearm(self.LightWeaponSets[actorside][r1] , self.Modules[actorside]);
	else
		weapon = CreateHDFirearm(self.HeavyWeaponSets[actorside][r2] , self.Modules[actorside]);
	end
	
	return weapon;
end
-----------------------------------------------------------------------------------------
-- Make explosive. actorside - actor faction number
-----------------------------------------------------------------------------------------
function CampaignFramework:MakeExplosive(actorside)
	local weapon;
	local r;
	
	weapon = nil;
	r = math.random(#self.ExplosiveSets[actorside]);
	
	weapon = CreateTDExplosive(self.ExplosiveSets[actorside][r] , self.Modules[actorside]);
	
	return weapon;
end
-----------------------------------------------------------------------------------------
-- Spawn troops of defending side
-----------------------------------------------------------------------------------------
function CampaignFramework:SpawnDefend(custompos)
	local actor = nil;
	local r;
	
	if MovableMan:GetMOIDCount() < self.MOIDLimit then
		r = math.random(#self.ActorSets[self.DefendFaction]);
		actor = CreateAHuman(self.ActorSets[self.DefendFaction][r] , self.Modules[self.DefendFaction]);

		-- probability to give a secondary weapon
		-- which is always light
		if math.random() < self.Probabilities[self.DefendFaction][2] then
			actor:AddInventoryItem(self:MakeWeapon(self.DefendFaction , true));
		end
		
		-- probability to give a heavy weapon
		if math.random() < self.Probabilities[self.DefendFaction][1] then
			actor:AddInventoryItem(self:MakeWeapon(self.DefendFaction , false));
		else
			actor:AddInventoryItem(self:MakeWeapon(self.DefendFaction , true));
		end
		
		-- probability to give an explosive
		if math.random() < self.Probabilities[self.DefendFaction][3] then
			actor:AddInventoryItem(self:MakeExplosive(self.DefendFaction));
		end

		-- probability to give a second explosive
		if math.random() < self.Probabilities[self.DefendFaction][4] then
			actor:AddInventoryItem(self:MakeExplosive(self.DefendFaction));
		end
		
		actor.AIMode = Actor.AIMODE_GOTO;
		actor:ClearAIWaypoints();
		actor:AddAISceneWaypoint(Vector(15 , 420));
		actor.Team = self.DefendTeam;
		if custompos == nil then
			actor.Pos = Vector(1010 , 420);
		else
			actor.Pos = custompos;
		end
		
		MovableMan:AddActor(actor);
	end
end
-----------------------------------------------------------------------------------------
-- Spawn troops of defending side
-----------------------------------------------------------------------------------------
function CampaignFramework:SpawnAttack(custompos)
	local actor = nil;
	local r;
	
	if MovableMan:GetMOIDCount() < self.MOIDLimit then
		r = math.random(#self.ActorSets[self.AttackFaction]);
		actor = CreateAHuman(self.ActorSets[self.AttackFaction][r] , self.Modules[self.AttackFaction]);

		-- probability to give a secondary weapon
		-- which is always light
		if math.random() < self.Probabilities[self.AttackFaction][2] then
			actor:AddInventoryItem(self:MakeWeapon(self.AttackFaction , true));
		end
		
		-- probability to give a heavy weapon
		if math.random() < self.Probabilities[self.AttackFaction][1] then
			actor:AddInventoryItem(self:MakeWeapon(self.AttackFaction , false));
		else
			actor:AddInventoryItem(self:MakeWeapon(self.AttackFaction , true));
		end
		
		-- probability to give an explosive
		if math.random() < self.Probabilities[self.AttackFaction][3] then
			actor:AddInventoryItem(self:MakeExplosive(self.AttackFaction));
		end

		-- probability to give a second explosive
		if math.random() < self.Probabilities[self.AttackFaction][4] then
			actor:AddInventoryItem(self:MakeExplosive(self.AttackFaction));
		end
		
		actor.AIMode = Actor.AIMODE_GOTO;
		actor:ClearAIWaypoints();
		actor:AddAISceneWaypoint(Vector(1010 , 420));
		actor.Team = self.AttackTeam;
		if custompos == nil then
			actor.Pos = Vector(15 , 420);
		else
			actor.Pos = custompos;
		end
		
		MovableMan:AddActor(actor);
	end
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function CampaignFramework:UpdateActivity()
	--Move the cursor.
	local cont = self.brain:GetController();

	if cont:IsState(Controller.PRESS_RIGHT) then
		self:RedrawPlate(self.Selection , false);
		local oldselection = self.Selection;
		--If right is pushed, move the cursor right.
		self.Selection = self.Selection + 1;
		--This makes sure it wraps around.
		if self.Selection > #self.Missions then
			self.Selection = 1;
		end
		
		if not self.AvailableMissions[self.Selection] then
			self.Selection = oldselection;
		end
		
		self:RedrawPlate(self.Selection , true);
	end
	
	if cont:IsState(Controller.PRESS_LEFT) then
		self:RedrawPlate(self.Selection , false);
		local oldselection = self.Selection;
		--If left is pushed, move the cursor left.
		self.Selection = self.Selection - 1;
		--This makes sure it wraps around.
		if self.Selection < 1 then
			self.Selection = #self.Missions;
		end

		if not self.AvailableMissions[self.Selection] then
			self.Selection = oldselection;
		end

		self:RedrawPlate(self.Selection , true);
	end

	FrameMan:SetScreenText(self.HelpText..self.Missions[self.Selection]["Description"], Activity.PLAYER_1, 0, 1, false);

	--If fire has been pushed, start mission.
	if cont:IsState(Controller.WEAPON_FIRE) then
		ActivityMan:StartActivity("GAScripted" , self.Missions[self.Selection]["Activity"]);
	end
	
	-- Make some funny action!
	if self.DefendSpawnTimer:IsPastSimMS(self.DefendSpawnInterval) then
		if not self.CPUBrainDead then
			self:SpawnDefend(nil);
			self.DefendSpawnTimer:Reset();
		end
	end

	if self.AttackSpawnTimer:IsPastSimMS(self.AttackSpawnInterval) then
		if not self.CPUBrainDead then
			self:SpawnAttack(nil);
			self.AttackSpawnTimer:Reset();
		end
	end
end
-----------------------------------------------------------------------------------------
-- Thats all folks!!!
-----------------------------------------------------------------------------------------